/*
//strcpy(szLCW,"1000000100000000");
Scrivere un programma in linguaggio C che, presa in ingresso una stringa binaria di 16 caratteri, stampi la codifica impulsiva dellLCW corrispondente.
*/
#include <stdio.h>
#include <conio.h>
#include <string.h>

#define LITTLEENDIAN (1)
#define BIGENDIAN (0)

int szBinarytoDec(char* szbinary, int ile);

int main (void)
{
    char szLCW[17];
    char ch;
    int i = 0;

    printf("Inserire LCW (16 char binari): ");
    while (i!=16)
    {
      ch = getche();
      if ((ch=='0') || (ch=='1'))
      {
        szLCW[i] = ch; szLCW[i+1]=0;
        i++;
      }
    }

    i = szBinarytoDec(szLCW, BIGENDIAN);
    printf("\nLCW in decimale (big endian): %d\n",i);

    for (i=strlen(szLCW)-1; i>=0; i--)
    {
      if (szLCW[i]=='0') printf("0 ");
      else printf("1 ");
    }
    printf("\n");

    for (i=strlen(szLCW)-1; i>=0; i--)
    {
      if (szLCW[i]=='0') printf("| ");
      else printf("||");
    }

    return 0;
}

int szBinarytoDec(char* szbinary, int ile)
{
  int iPos, iRv = 0;

  if (ile==0) strrev(szbinary); // big endian

  for (iPos=strlen(szbinary)-1; iPos>=0; iPos--)
  {
    iRv = iRv << 1;
    if (szbinary[iPos]=='1') iRv += 1;
  }

  return iRv;
}


/*
char* DectoszBin(int quale, int contenitore, char* szbinary)
{
  unsigned int mask;
  int i;

  mask = 0;
  mask = 1 << (contenitore-1);

  i = 0;
  while(mask)
  {
    if (quale & mask) szbinary[i] = '1'; else szbinary[i] = '0';

    mask = mask >> 1;
    i++;
  }
  szbinary[i] = 0;

  return szbinary;
}
*/


